#version 330

in vec3 pos;
in vec3 normal;

out vec3 worldNormal;
out vec3 worldPos;

uniform mat4 modelMatrix;
uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;

void main(){
	worldNormal = (modelMatrix * vec4(normal, 0.0f)).xyz;
	worldPos = (modelMatrix * vec4(pos, 1.0f)).xyz;
	gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(pos, 1.0f);
}