#version 330

in vec3 pos;
in vec3 normal;
in vec2 uv;
in ivec4 boneIds;
in vec4 boneWeights;

out vec3 worldNormal;
out vec3 worldPos;
out vec2 fragUV;

uniform mat4 modelMatrix;
uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;
uniform mat4 bones[100];

void main(){
    mat4 animation = bones[boneIds[0]] * boneWeights[0];
    animation += bones[boneIds[1]] * boneWeights[1];
    animation += bones[boneIds[2]] * boneWeights[2];
    animation += bones[boneIds[3]] * boneWeights[3];

    vec4 posAnim = animation * vec4(pos, 1.0f);
	vec4 normalAnim = animation * vec4(normal, 0.0f);

	fragUV = uv;
	worldNormal = (modelMatrix * normalAnim).xyz;
	worldPos = (modelMatrix * posAnim).xyz;
	gl_Position = projectionMatrix * viewMatrix * modelMatrix * posAnim;
}