#version 330

in vec3 pos;
in vec3 normal;
in vec2 uv;

out vec2 fragUV;

uniform mat4 modelMatrix;
uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;
uniform vec3 camPos;


void main(){
	vec3 toCamera = normalize(camPos - pos);
    vec3 up = vec3(0.0f, 0.0f, 1.0f);
    vec3 final = cross(toCamera, up);

	fragUV = uv;
	gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(pos, 1.0f);
}